import { VNode } from "preact";
export interface Renderer {
    html: string;
    reset(): void;
    onProp(name: string, value: string | boolean | undefined | null, depth: number): void;
    onOpenTag(name: string, hasChildren: boolean, isVoid: boolean, depth: number): void;
    onOpenTagClose(name: string, hasAttributes: boolean, isVoid: boolean, hasChildren: boolean, depth: number): void;
    onTextNode(text: string, depth: number): void;
    onCloseTag(name: string, isVoid: boolean, depth: number): void;
    onDangerousInnerHTML(html: string): void;
}
export interface Options {
    sort: boolean;
    shallow: boolean;
    depth: number;
}
export declare const createRenderer: (renderer: Renderer, options?: Partial<Options>) => (vnode: VNode) => string;
export declare function renderToString(vnode: VNode | string | undefined, renderer: Renderer, depth: number, options: Options): void;
